/*
 *  timeEventRecorder.h
 *  midiRecorder
 *
 *  Created by Lucas Vickers on 9/25/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef _TIME_EVENT_RECORDER_H
#define _TIME_EVENT_RECORDER_H

#include <set>
#include <vector>
#include <map>
#include <pthread.h>

#include "idValue.h"
#include "timeEvent.h"


// Class is thread safe

class TimeEventRecorder {
public:
	TimeEventRecorder();
	
	void setEvent(int id, float time, float value);

	// get values for all known ID's at certain time
	// will be linearly interpolated between points
	std::vector<IdValue> getValues(float time);
	// find out what id's have recordings
	std::set<int> getExistingIds();
	
	typedef std::set<TimeEvent, lcompare> TimeEventSet;
	typedef std::map<int, TimeEventSet> EventIdMap;
	
	
protected:
	EventIdMap _map;
	pthread_mutex_t _mutex;
	
	static const bool TER_DEBUG = false;

};



#endif
